﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;

namespace FtpUpload
{
    public partial class FormFtpUpload : Form
    {
        private WebClient ftpClient;

        public FormFtpUpload()
        {
            InitializeComponent();
        }

        private void buttonVyhledatLokalniSoubor_Click(object sender, EventArgs e)
        {
            // vyhledani lokalniho souboru pro upload
            OpenFileDialog openDlg = new OpenFileDialog();
            openDlg.Filter = "Všechny soubory|*.*";
            openDlg.FilterIndex = 1;
            openDlg.RestoreDirectory = true;

            if (openDlg.ShowDialog() == DialogResult.OK)
            {
                textBoxLokalniSoubor.Text = openDlg.FileName;
            }
        }

        private void buttonUpload_Click(object sender, EventArgs e)
        {
            // kontrola, jestli je vyplneno jmeno
            if (textBoxJmeno.Text.Trim().Length == 0)
            {
                MessageBox.Show("Není zadáno jméno.", Text,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            // kontrola, jestli je vyplneno heslo
            if (textBoxHeslo.Text.Trim().Length == 0)
            {
                MessageBox.Show("Není zadáno heslo.", Text,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            // kontrola, jestli je vyplnena URI serveru
            if (textBoxUri.Text.Trim().Length == 0)
            {
                MessageBox.Show("Není zadána URI serveru.", Text,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            // kontrola, jestli je vyplnena cesta k souboru
            if (textBoxLokalniSoubor.Text.Trim().Length == 0)
            {
                MessageBox.Show("Není zadána cesta k souboru pro upload.", Text,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            // kontrola, jestli lokalni soubor existuje
            if (!File.Exists(textBoxLokalniSoubor.Text.Trim()))
            {
                MessageBox.Show("Uvedený soubor neexistuje.", Text,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            // vytvoreni objektu WebClient a nastaveni jmena a hesla
            using (ftpClient = new WebClient())
            {
                ftpClient.Proxy = null;
                ftpClient.Credentials = new NetworkCredential(textBoxJmeno.Text.Trim(),
                    textBoxHeslo.Text.Trim());

                // upload souboru
                FtpUploadFile(ftpClient, textBoxLokalniSoubor.Text.Trim(), textBoxUri.Text.Trim());
            }
        }

        private void FtpUploadFile(WebClient ftpClient, String localFile, String ftpServerUri)
        {
            try
            {
                ftpClient.UploadFile(ftpServerUri + "/" + new FileInfo(localFile).Name, localFile);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
